/*
 * linux/include/asm-arm/arch-mb8aa0350/entry-macro.S
 * IRQ demultiplexing for MB8AA0350
 *
 * Copyright (C) 2007 Fujitsu
 *
 * This program is free software ;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation	;  either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program ;  if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include <asm/hardware.h>

	.macro  disable_fiq
	.endm

	.macro  get_irqnr_preamble, base, tmp
	.endm

	.macro  arch_ret_to_user, tmp1, tmp2
	.endm

	.macro  get_irqnr_and_base, irqnr, irqstat, base, tmp
	ldr     \base, =IO_ADDRESS(VIC0_BASE)
	mov     \irqnr, #0
	ldr     \irqstat, [\base]                        @ lower 32 interrupts
	cmp     \irqstat, #0
	bne     1001f

	ldr     \base, =IO_ADDRESS(VIC1_BASE)
	ldr     \irqstat, [\base]                        @ upper 32 interrupts
	cmp     \irqstat, #0
	beq     1002f
	mov     \irqnr, #0x20

1001:
	movs    \tmp, \irqstat, lsl #16
	movne   \irqstat, \tmp
	addeq   \irqnr, \irqnr, #16

	movs    \tmp, \irqstat, lsl #8
	movne   \irqstat, \tmp
	addeq   \irqnr, \irqnr, #8

	movs    \tmp, \irqstat, lsl #4
	movne   \irqstat, \tmp
	addeq   \irqnr, \irqnr, #4

	movs    \tmp, \irqstat, lsl #2
	movne   \irqstat, \tmp
	addeq   \irqnr, \irqnr, #2

	movs    \tmp, \irqstat, lsl #1
	addeq   \irqnr, \irqnr, #1
	orrs    \base, \base, #1

1002:
	.endm
